<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

class create_ss7_isup_profile
{
	
	private $error= "";				//Contains validation errors
	public $error_counter="";		//Contains the number of errors in the form
	public $edit="";				//Contains database returned values for editing
	public $profile_name = array();	//Contains the profile names within the database
	public $profile_counter = "";	//Contains the number of profiles in the database
	private $pick="";				//Contains the data for what was returned to the form
	public $ssf="";					//Contains the value of SSF
	public $spc;					//Contains the value of spc
	private $db_location="";		//Contains the database location
	private $table_name="";			//Contains the database table name
	public $profile="";				//Contains the profile name
	
	//Display function
	function display()
	{
		$this->db_location = "sqlite:../sqlite/cardinfo.db";

		if ($_SESSION['id_num'] == "") 
		{ 
			echo "<h3>SS7 ISUP Profile Creation</h3>";		
		} 
		else 
		{ 
			echo "<h3>SS7 ISUP Profile - Edit</h3>"; 
		} 
		
		if ($_SESSION['profile_num_isup'] == "")
		{
			$a = 1;
			$_SESSION['profile_num_isup'] = $a;
		}
		elseif ($_SESSION['profile_num_isup'] != "")
		{
			$a = $_SESSION['profile_num_isup'];
			$a++;
			$_SESSION['profile_num_isup'] = $a;
		}
		
		$this->check_submit();
		
		$this->table_name = "ss7_route_profile";
		$this->get_profiles();
		
		?>
	<p>
    	The fourth step of the SS7 configuration is the creation of an ISUP Interface.<br />
        ISUP Stands for Integrated Services Digital Network User Part.<br /> 
        An ISUP Interface is used mainly for Call Control. It is used to manage voice and data calls over the PSTN (Public Switched Telephone Network).<br />
        An ISUP Interface can only use 1 SS7 Route for call control.
    </p>
	<form name="create_profile" method="post">
		<hr />    		   
		<table>
			<tr>
				<td>Profile Name</td>
				<td align="right"><input type="text" name="profile_name" value="<?php if ($this->profile != "") { echo $this->profile; } else { echo "SS7_ISUP$a"; }?>" style="text-align:right; width:150px" /></td>
				<td><?php echo $this->error['profile_name']; ?></td>
			</tr>   
            <tr>
            	<td>Self Point Code</td>
            	<td align="right"><input type="text" name="spc" value="<?php echo $this->spc; ?>" style="text-align:right; width:40px" /></td>
                <td><?php echo $this->error['spc']; ?></td>
            </tr>         
            <tr>
              	<td>SSF</td>
                <td align="right">
                   	<select name="ssf">
            	       	<option value="nat" <?php if ($this->pick['ssf_nat'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">NAT</option>
                        <option value="int" <?php if ($this->pick['ssf_int'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">INT</option>
                        <option value="spare" <?php if ($this->pick['ssf_spare'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">SPARE</option>
                        <option value="res" <?php if ($this->pick['ssf_res'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">RES</option>
                    </select>
               </td>
               <?php if (isset($this->error['ssf'])) { ?> <td><font color="red"><?php echo $this->error['ssf']; ?></font></td><?php } ?>
            </tr>
            <tr>
            	<td>Route</td>
                <td align="right">
					<select name="route">
				<?php
				for ($a = 0; $a < $this->profile_counter; $a++)
				{ 
						$hash = "route-" . $this->profile_name[$a]['profile_name'];
						echo "<option value=\"" . $this->profile_name[$a]['profile_name'] . "\""; if ($this->pick[$hash] == "yes") { ?> selected="selected" <?php } echo " style=\"text-align:right\" >" . $this->profile_name[$a]['profile_name'] . "</option>\n";
				}
				?>
				   </select>
                </td>
            </tr>                       
       </table>
		<br />
        <hr />
		<input type="submit" name="create" value="<?php if ($_SESSION['id_num'] == "") { echo "Create Profile"; } else { echo "Save Profile"; } ?>" style="background-color: #CCC"/>
		<input type="submit" name="cancel" value="<?php if ($_SESSION['id_num'] == "") { echo "Cancel Profile Creation"; } else { echo "Cancel Profile Editing"; } ?>" style="background-color: #CCC"/>
	</form>         
	<?php
	}	
	
	//Validates the Form
	function validation()
	{
		
		//Grab the profile name and make sure there isn't a profile already in the database
		//Only to occur if you are making a new profile
		if ($_SESSION['id_num'] == 0)
		{	
			$this->table_name = "ss7_route_profile";
			$this->get_profiles();
			
			for ($z = 0; $z <= $this->profile_counter; $z++)
			{
				if (strtoupper($this->profile_name[$z]['profile_name']) == strtoupper($_REQUEST['profile_name']))
				{
					$this->error['profile_name'] = "<font color=\"red\">Profile already <strong>EXISTS</strong>. Please use a different profile name</font>";
					$this->error_counter++;
				}
			}			
			$this->table_name = "ss7_linkset_profile";
			$this->get_profiles();
			
			for ($z = 0; $z <= $this->profile_counter; $z++)
			{
				if (strtoupper($this->profile_name[$z]['profile_name']) == strtoupper($_REQUEST['profile_name']))
				{
					$this->error['profile_name'] = "<font color=\"red\">Profile already <strong>EXISTS</strong>. Please use a different profile name</font>";
					$this->error_counter++;
				}
			}	
			$this->table_name = "ss7_isup_profile";
			$this->get_profiles();
			
			for ($z = 0; $z <= $this->profile_counter; $z++)
			{
				if (strtoupper($this->profile_name[$z]['profile_name']) == strtoupper($_REQUEST['profile_name']))
				{
					$this->error['profile_name'] = "<font color=\"red\">Profile already <strong>EXISTS</strong>. Please use a different profile name</font>";
					$this->error_counter++;
				}
			}							
		}
		
		//Makes sure the user enters a profile name
		if ($_REQUEST['profile_name'] == "")
		{
			$this->error['profile_name'] = "<font color=\"red\">Please Enter a Profile Name</font>";
			$this->error_counter++;
		}		
		
		if ($_REQUEST['spc'] == "")
		{
			$this->error['spc'] = "<font color=\"red\">Please Enter a <b>Self Point Code</b></font>";
			$this->error_counter++;
		}
		elseif (!is_numeric($_REQUEST['spc']))
		{
			$this->error['spc'] = "<font color=\"red\">Please Enter a <b>NUMERIC</b> value for the <b>Self Point Code</b></font>";
			$this->error_counter++;
		}

	}	
	
	
	//Retrieves all the SS7 route/linkset Profile Names
	function get_profiles()
	{
		$a = 0;
		$this->db_location = "sqlite:../sqlite/cardinfo.db";
		
		$select = "SELECT profile_name FROM " . $this->table_name . ";";

		try
		{
			//open the database
			$db = new PDO($this->db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				$this->profile_name[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}

		$this->profile_counter = $a;
	}	

	//Function to return the proper values when entering the page
	function check_submit()
	{
		if ($_REQUEST['ssf'] == "nat")
		{
			$this->pick['ssf_nat'] = "yes";
		}
		elseif ($_REQUEST['ssf'] == "int")
		{
			$this->pick['ssf_int'] = "yes";
		}
		elseif ($_REQUEST['ssf'] == "spare")
		{
			$this->pick['ssf_spare'] = "yes";
		}
		elseif ($_REQUEST['ssf'] == "res")
		{
			$this->pick['ssf_res'] = "yes";
		}
		elseif ($this->edit['ssf'] == "nat")
		{
			$this->pick['ssf_nat'] = "yes";
		}
		elseif ($this->edit['ssf'] == "int")
		{
			$this->pick['ssf_int'] = "yes";
		}
		elseif ($this->edit['ssf'] == "spare")
		{
			$this->pick['ssf_spare'] = "yes";
		}
		elseif ($this->edit['ssf'] == "res")
		{
			$this->pick['ssf_res'] = "yes";
		}	

		$this->table_name = "ss7_route_profile";
		$this->get_profiles();

		for ($a = 0; $a < $this->profile_counter; $a++)
		{
			$hash = "route-" . $this->profile_name[$a]['profile_name'];
			//echo $_REQUEST['route'] . " AND " . $this->profile_name[$a]['profile_name'] . "<br />";
			//echo "hash = $hash<br />";
			
			if ($_REQUEST['route'] == $this->profile_name[$a]['profile_name'])
			{
				$this->pick[$hash] = "yes";
			}
			elseif ($this->edit['route'] == $this->profile_name[$a]['profile_name'])
			{
				$this->pick[$hash] = "yes";
			}
			
			//echo "pick = " . $this->pick[$hash]  ."<br />";
		}
	}
}