<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

//Starts PHP Sessions
session_start();

include 'transcoding_class.php';
include '../database_classes.php';

$transcode = new transcoding_class;
$transcode->data = new database_class;
$transcode->db_location = "sqlite:../sqlite/cardinfo.db";

if ($_SESSION['username'] != "")
{
	//FusionPBX Integration
	require_once "../fusionpbx/includes/header.php";

	$transcode->get_info();
	$transcode->get_codecs();

	//Decide which setup type to display
	$bind_table = "bind_transcode";
	$codec_table = "user_codecs";
	
	$codec = $transcode->data->select_statement($transcode->db_location, $codec_table, "codec_syntax", "id = 1");
	$bind = $transcode->data->select_statement($transcode->db_location, $bind_table, "bind_addr", "id = 1");

	//echo "bind address = " . $bind['bind_addr'] . " codec = " . $codec['codec_syntax'] . "<br />";

	if ($codec['codec_syntax'] != "" && $bind['bind_addr'] == "")
	{
		$_SESSION['transcoder_session'] = "single";
	}
	elseif ($bind['bind_addr'] != "" && $codec['codec_syntax'] == "")
	{
		$_SESSION['transcoder_session'] = "distributed";
	}
	elseif ($codec['codec_syntax'] == "" && $bind['bind_addr'] == "")
	{
		$_SESSION['transcoder_session'] = "single";
	}		
	elseif ($bind['bind_addr'] != "" && $codec['codec_syntax'] != "")
	{
		$_SESSION['transcoder_session'] = "single";
	}
	
	//Compare the values. Use the database values, if database values don't exist, use ifconfig values
	for ($a = 0; $a < $transcode->counter; $a ++)
	{
		$table_name = "transcode";
		$where_param = "id = $a";
		$exist[$a] = $transcode->data->select_statement($transcode->db_location, $table_name, "*", $where_param);
		
		$transcode->find_values($exist, $a);
	}

	if ($_REQUEST['install'] == "Generate Configuration")
	{
		if ($_REQUEST['bind_addr'] != "" || $_REQUEST['bind_port'] != "")
		{
			if (!preg_match('/^(([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]).){3}([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/',$_REQUEST['bind_addr']))
			{
				$bind_error = "IP Address entered is not a valid IPv4 Address";
				$no_configure = "yes";
			}

			if (!is_numeric($_REQUEST['bind_port']))
			{
				$port_error = "Port Number must be a numeric value";
				$no_configure = "yes";
			}
		}
	}

    //Goes through the request variables and checks what was clicked on
	foreach ($_REQUEST as $key => $value)
	{	
		//echo "key = $key and value= $value<br />";
		for ($a = 0; $a < $transcode->counter; $a ++)
		{			
			if ($key == "accept$a" && $value == "USE")
			{	
				//Validate the IP Address
				if (!preg_match('/^(([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]).){3}([1-9]?[0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/',$transcode->array_ip_addr[$a]))
				{
					$error_ip[$a] = "yes";
					$ip_error = "<font color=\"red\">Please correct the IP Address for " . $transcode->array_name[$a] . "</font>";
				}
				else
				{
					$error_ip[$a] = "";
				}
				//Validate the Subnet Mask
				if (!preg_match('/^(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)(?:[.](?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)){3}$/', $transcode->array_mask[$a]))
				{
					$error_mask[$a] = "yes";
					$mask_error = "<font color=\"red\">Please correct the Subnet Mask for " . $transcode->array_name[$a] . "</font>";
				}
				else
				{
					$error_mask[$a] = "";
				}
				
				//If both pass, proceed to configuration
				if ($error_ip[$a] == "" && $error_mask[$a] == "")
				{
					//Only do this if it is a sangoma device	
					//Enter the IP Address and Subnet Mask into the linux system and bring that interface up
					$transcode->compare_mac($transcode->array_mac[$a]);
					
					if ($transcode->is_sangoma == "YES")
					{
						//echo "IP = " . $transcode->array_ip_addr[$a] . "<br />";
						if ($transcode->array_ip_addr[$a] == "")
						{
							$transcode->array_ip_addr[$a] = "0.0.0.0";
						}
						//$command = "/sbin/ifconfig " . $transcode->array_name[$a] . " down";
						//echo $command . "<br />";
						//exec($command);
						$command = "/sbin/ifconfig " . $transcode->array_name[$a] . " " . $transcode->array_ip_addr[$a] . " netmask " . $transcode->array_mask[$a];
						//echo $command . "<br />";
						exec($command);
						$command = "/sbin/ifconfig " . $transcode->array_name[$a] . " up";
						//echo $command . "<br />";
						exec($command);
						sleep(10);
					}
					
					//Scan for modules
					$command = "/usr/sbin/sngtc_tool -dev '" . $transcode->array_name[$a] . "' -list_modules | grep 'MAC' -c";
					//echo $command . "<br />";
					exec ($command, $sngtc);
	
					/*for ($l = 0; $l < count($sngtc); $l++)
					{
						echo $sngtc[$l] . "<br />";
					}*/
					//echo "moudle = " . $sngtc[0] . " and count = " . count($sngtc) . "<br />";
					if (count($sngtc) > 0)
					{
						//echo "i am here<br />";
						$transcode->num_modules[$a] = $sngtc[0];
						
						//Place in database
						$transcode->initial_database($a, $sngtc[0]);
						$_SESSION['proceed'] = "yes";
						
						header( 'Location:transcoding.php' ) ;	
					}
					else
					{
						//There is an error
						$error_modules[$a] = "<font color=\"red\">ERROR</font>";
						$table_name = "transcode";
						$where = "interface = \"" . $transcode->array_name[$a] . "\"";
						$transcode->data->delete_generic($transcode->db_location, $table_name, $where);
					}
				}
			}
			if ($key == "scan$a" && $value == "SCAN")
			{
				//Scan for modules
				$command = "/usr/sbin/sngtc_tool -dev '" . $transcode->array_name[$a] . "' -list_modules | grep 'MAC' -c";
				//echo $command . "<br />";
				exec ($command, $sngtc);
	
				/*for ($l = 0; $l < count($sngtc); $l++)
				{
					echo $sngtc[$l] . "<br />";
				}*/
	
				if (count($sngtc) > 0)
				{
					$transcode->num_modules[$a] = $sngtc[0];
					
					//Place in database
					$transcode->initial_database($a, $sngtc[0]);
					$_SESSION['proceed'] = "yes";
					
					header( 'Location:transcoding.php' ) ;	
				}
				else
				{
					//There is an error
					$error_modules[$a] = "<font color=\"red\">ERROR</font>";
					$table_name = "transcode";
					$where = "interface = \"" . $transcode->array_name[$a] . "\"";
					$transcode->data->delete_generic($transcode->db_location, $table_name, $where);
				}
			}
			if ($key == "done$a" && $value="Accept")
			{
				//IP Nibble entered
				//Place nibble in database
				$transcode->update_nibble($a);
				
			}
			if ($key == "delete$a" && $value == "Remove")
			{
				$command = "/sbin/ifconfig " . $transcode->array_name[$a] . " down";
				//echo $command . "<br />";
				shell_exec($command);
				
				$table_name = "transcode";
				$where = "interface = \"" . $transcode->array_name[$a] . "\"";

				$transcode->data->delete_generic($transcode->db_location, $table_name, $where);
				header( 'Location:transcoding.php' ) ;	
			}
		}
	}
	
	
	
	//MAIN PAGE
	
		
	?>
    <h2>Media Processing Installation Page</h2>

	<hr />
    
    <h4>Media Processing Configuration</h4>
    <form method="post">
    	<p>
        	Please specify whether the Media Processing will be done on this local server or done by a server on the Local Area Network (LAN)
        </p>
        <input type="submit" name="single" value="Local Setup" style="background-color: #CCC" />
        <input type="submit" name="distributed" value="LAN Setup" style="background-color: #CCC" />
        <br />
        <hr />
        <br />
        Please select the codecs that will be used for this transcoding setup:<br />
	<?php
	
		//Distributed Setup
		if ($_REQUEST['distributed'] == "LAN Setup" || $_SESSION['transcoder_session'] == "distributed")
		{
			$_SESSION['transcoder_session'] = "distributed";
	?>

        <table>
        	
	<?php
		echo "<tr>\n";
		for ($l = 1; $l < count($transcode->codec_array); $l++)
		{
			$modulus = $l % 4;
			$hash = "codec$l";
			echo "<td>\n<input type=\"checkbox\" name=\"codec$l\" value=\"" . $transcode->codec_array[$l] . "\"";
			if ($_REQUEST[$hash] == $transcode->codec_array[$l] )
			{						
				 echo " checked=\"checked\" ";
			}			
			echo "/>\n</td>\n";
			echo "<td align=\"left\">" . $transcode->codec_names[$l] . " " . $transcode->codec_info[$l] . "</td>\n";

			if ($modulus == 0)
			{
				echo "</tr>\n<tr>\n";
			}
			
			$counter++;
		}
	
	?>
			
        </table> 
        <br />      
    
        If media processing server is not on the local machine, please specify the IP Address and the Port Number of the Media Processing Server:
        
        <table>
        	<tr>
            	<td>Address:</td>
                <td><input type="text" name="bind_addr" value="<?php echo $transcode->bind_addr; ?>" style="text-align:right"/></td>
                <td><font color="red"><?php echo $bind_error ?></font></td>
           </tr>
           <tr>
           		<td>Port:</td>
                <td><input type="text" name="bind_port" value="<?php echo $transcode->bind_port; ?>" style="text-align:right"/></td>
                <td><font color="red"><?php echo $port_error ?></font></td>
           </tr>
       	</table>
    	<br />
    	<input type="submit" name="install" value="Generate Configuration" style="background-color: #CCC"/>         
        <br />	
     <?php
        }	
		
		
		//Local Setup		
		elseif ($_REQUEST['single'] == "Local Setup" || $_SESSION['transcoder_session'] == "single")
		{
			$_SESSION['transcoder_session'] = "single";
	?>    
        <table>
        	
	<?php
		echo "<tr>\n";
		for ($l = 1; $l < count($transcode->codec_array); $l++)
		{
			$modulus = $l % 4;
			$hash = "codec$l";
			echo "<td>\n<input type=\"checkbox\" name=\"codec$l\" value=\"" . $transcode->codec_array[$l] . "\"";
			if ($_REQUEST[$hash] == $transcode->codec_array[$l] )
			{						
				 echo " checked=\"checked\" ";
			}			
			echo "/>\n</td>\n";
			echo "<td align=\"left\">" . $transcode->codec_names[$l] . " " . $transcode->codec_info[$l] . "</td>\n";

			if ($modulus == 0)
			{
				echo "</tr>\n<tr>\n";
			}
			
			$counter++;
		}
	
	?>
			
        </table> 
    	<br />
        If the media processing on this server will be used by other servers on the LAN, please verify that the IP address used is the local LAN IP:
        
        <table>
        	<tr>
            	<td>Address:</td>
                <td><input type="text" name="bind_addr" value="<?php echo $transcode->bind_addr; ?>" style="text-align:right"/></td>
                <td><font color="red"><?php echo $bind_error ?></font></td>
           </tr>
           <tr>
           		<td>Port:</td>
                <td><input type="text" name="bind_port" value="<?php echo $transcode->bind_port; ?>" style="text-align:right"/></td>
                <td><font color="red"><?php echo $port_error ?></font></td>
           </tr>
       	</table>
       
        <br />	
		<p>
        	To configure media processing, please select the appropriate interface.<br />
            Please note that if your interfaces are not listed, you will have to build the media processing drivers.
	    </p>        
    	<table>
   	 		<th>Interface</th>
        	<th>IP Address</th>
        	<th>Subnet Mask</th>
        	<th>Sangoma Device?</th>
        	<th></th>
        <?php
			//if ($_SESSION['proceed'] == "yes")
			//{
		?>
        	<th>Modules Detected</th>
        	<th></th>
        	<th>4th Octet of IP</th>
        <?php
			//}
			for ($a = 0; $a < $transcode->counter; $a ++)
			{
				$transcode->compare_mac($transcode->array_mac[$a]);
			    echo "<tr align=\"center\">\n";
				if (isset($error_modules[$a]))
				{
					echo "<td><font color=\"red\">" . $transcode->array_name[$a] . "</font><br />" . $error_modules[$a] . "</td>\n";
				}
				else
				{
					echo "<td>" . $transcode->array_name[$a] . "<br /></td>\n";
				}
				if ($transcode->is_sangoma == "YES")
				{
					if ($error_ip[$a] == "yes")
					{
						echo "<td><input type=\"text\" name=\"ip_addr_" . $a . "\" value=\"" . $transcode->array_ip_addr[$a] . "\" style=\"text-align:right;color:red\" /></td>\n";
					}
					else
					{
						echo "<td><input type=\"text\" name=\"ip_addr_" . $a . "\" value=\"" . $transcode->array_ip_addr[$a] . "\" style=\"text-align:right\" /></td>\n";						
					}
					
					if ($error_mask[$a] == "yes")
					{					
						echo "<td><input type=\"text\" name=\"netmask" . $a . "\" value=\"" . $transcode->array_mask[$a] . "\" style=\"text-align:right; color:red\" /></td>\n";
					}
					else
					{
						echo "<td><input type=\"text\" name=\"netmask" . $a . "\" value=\"" . $transcode->array_mask[$a] . "\" style=\"text-align:right\" /></td>\n";
					}					
				}
				elseif ($transcode->is_sangoma == "NO")
				{
					echo "<td><input type=\"text\" name=\"ip_addr_" . $a . "\" value=\"" . $transcode->array_ip_addr[$a] . "\" style=\"text-align:right;background-color: grey\" /></td>\n";
					echo "<td><input type=\"text\" name=\"netmask" . $a . "\" value=\"" . $transcode->array_mask[$a] . "\" style=\"text-align:right;background-color: grey\" /></td>\n";
				}
				
				echo "<td>" . $transcode->is_sangoma . "</td>\n";	
		?>
            		<td><input type="submit" name="accept<?php echo $a; ?>" value="USE" style="text-align:right;background-color: #CCC" /></td>
		<?php
				if ($exist[$a]['id'] != "")
				{
		?>                    
            		<td><?php echo $transcode->num_modules[$a]; ?></td>
            		<td><input type="submit" name="scan<?php echo $a; ?>" value="SCAN" style="text-align:right;background-color: #CCC" /></td>
            		<td><input type="text" name="nibble<?php echo $a; ?>" value="<?php echo $transcode->array_nibble[$a]; ?>" style="text-align:right; width: 50px"/></td>
                    <td><input type="submit" name="done<?php echo $a; ?>" value="Accept" style="text-align:right;background-color: #CCC" /></td>
                    <td><input type="submit" name="delete<?php echo $a; ?>" value="Remove" style="text-align:right;background-color: #CCC" /></td>
        <?php        			
				}
				else
				{
		?>                    
            		<td></td>
            		<td></td>
            		<td></td>
                    <td></td>
                    <td></td>
        <?php        			
				}
			    echo "</tr>\n";
			}
		?>
		</table> 
        <br />
        <?php
			if (isset($ip_error) || isset($mask_error))
			{
				echo "<h4>ERRORS</h4>";
			}
			if (isset($ip_error))
			{
				echo "<b>$ip_error</b><br />";
			}
			if (isset($mask_error))
			{
				echo "<b>$mask_error</b>";
			}
			if (isset($ip_error) || isset($mask_error))
			{
				echo "<br />";
			}
		?>
    	<br />
    	<input type="submit" name="install" value="Generate Configuration" style="background-color: #CCC"/> 
    	<br />
        <hr />
		
        <h4>Media Processing Driver Build Tool</h4>

		<p>
        	This portion of the installer builds the required drivers needed to operate the D-Series hardware within the system.<br />
            This is optional, as most systems already have the required media processing modules installed.<br /><br />
			<font color="red">NOTE: If you choose to build the media processing drivers and you have Broadcom NetExtreme or Micrel Ethernet Drivers loaded on your system, you WILL lose network connectivity,<br />
            which also can result in the loss of connection to the Gateway Web Server</font>            
        </p>
    	<input type="submit" name="build" value="Build Ethernet Drivers" style="background-color: #CCC" /> 

    </form>
    
    
    <?php
		}
	//REQUST PROCESSING
	
	
	//Performs the Ethernet Driver Build
	if ($_REQUEST['build'] == "Build Media Processing Drivers")
	{
	?>
    <hr />
    <h3>Installation Status</h3>
    <table>
    	<th>Process</th>
        <th>Status</th>
        <tr>
            <td>Removing old Drivers</td>
            <?php
			exec ("lsmod | grep tg3 | cut -d' ' -f1", $output);
			if ($output[0] == "tg3")
			{
				$tg3 = "install";
			}
			exec ("lsmod | grep ks8842_pci | cut -d ' ' -f1", $output);
			if ($output[0] == "ks8842_pci")
			{
				$micrel = "install";
			}
			
			//echo "$tg3, $micrel";
			
			if ($tg3 == "install")
			{
				exec ("modprobe -r tg3");
				exec ("echo $?", $tg3_exit);
				if ($tg3_exit[0] != 0)
				{
					$tg3_error = "yes";
				}
			}
			if ($micrel == "install")
			{
				exec ("modprobe -r ks8842_pci");
				exec ("echo $?", $micrell_exit);
				if ($micrell_exit[0] != 0)
				{
					$micrell_error = "yes";
				}
			}
			
			if ($tg3_error == "yes" || $micrell_error == "yes")
			{
				?>
            <td width="100px" align="right"><font color="RED">ERROR</font></td>
            	<?php
				//Create Error Message
				//Failed to remove modules
			}
			else
			{
				?>
            <td width="100px" align="right"><font color="green">DONE</font></td>
         	   <?php
			   $continue = "yes";
			}
			?>
        </tr>   
        <?php
			if ($continue == "yes")
			{
		?>
        <tr> 
            <td>Installing Media Processing Drivers</td>        
            <?php
			
				//Clean out the directories
				$path = "cd " . $_SESSION['smg_root_path'] . "/src/tg3-3.112d && make clean";
				exec ($path);
				$path = "cd " . $_SESSION['smg_root_path'] . "/src/ks884x-linux-20090828 && make clean";
				exec ($path);
				$path = "cd " . $_SESSION['smg_root_path'] . "/src/ksz884x-1.0.13 && make clean";
				exec ($path);
				$path = "cd " . $_SESSION['smg_root_path'] . "/src && ". $_SESSION['smg_root_path'] . "/src/install.sh silent &> transcoder_install.txt";
				exec ($path, $install_output);
				
				/*echo "<pre>";
				for ($a = 0; $a < count($install_output); $a++)
				{
					echo "$install_output[$a]<br />";
				}
				echo "</pre>";*/
				
				exec ("echo $?", $check_status);
				//echo $check_status[0];
				if ($check_status[0] == 0)
				{
					$cmd = "grep -E 'Error' -c " . $_SESSION['smg_root_path'] . "/src/transcoder_install.txt";
					exec ($cmd, $check);
					if ($check[0] == 0)
					{	
			?>
            <td width="100px" align="right"><font color="green">DONE</font></td>
            <?php
						$initialize_driver = "yes";
					}
					if ($check[0] > 0)
					{
						//Install script had errors in it	
			?>
            <td width="100px" align="right"><font color="red">ERROR</font></td>
            <?php
					}
					
					if ($initialize_driver = "yes")
					{					
			?>
        <tr>
            <td>Initializing Drivers</td>
            <?php
						exec ("lsmod | grep tg3 | cut -d' ' -f1", $output);
						if ($output[0] == "tg3")
						{
							$tg3 = "good";
						}
						else
						{
							$tg3 = "error";
						}
						
						exec ("lsmod | grep ks8842_pci | cut -d ' ' -f1", $micrel_output);
						//echo $micrel_output[0];
						if ($micrel_output[0] == "ks8842_pci")
						{
							$micrel = "good";
						}
						else
						{
							$micrel = "error";
						}
					
						if ($tg3 == "good" && $micrel == "good")
						{
			?>
            <td width="100px" align="right"><font color="green">DONE</font></td>
            <?php
							$complete = "yes";
						}
						else
						{
							//Could not bring the interfaces up
			?>
            <td width="100px" align="right"><font color="red">ERROR</font></td>
            <?php
							$interface = "error";
						}
			?>
            
        </tr>
        	<?php
					}				
				}
				else
				{
					//Install Script Failed to execute	
			?>
            <td width="100px" align="right"><font color="red">ERROR</font></td>
            <?php
					$install_script = "error";
				}
			?>
        </tr>
    </table>    

        <?php
				if ($complete == "yes")
				{
					$path = "rm -fr " . $_SESSION['smg_root_path'] . "/src/transcoder_install.txt";
					//exec ($path);
					echo "<p>
					Media Processing Drivers have now been built and loaded onto the system. You can now continue with your Media Processing configuration<br />
					</p>";
				}
				elseif ($interface == "error")
				{
					$body = "Dear Support;%0D%0AI am having trouble bringing up my media processing drivers using the Sangoma Media Gateway Media Processing Web Installation.%0D%0AAttached is the output from the media processing installation%0D%0ARegards";
					$file_location = $_SESSION['smg_root_path'] . "/nginx/html/php/installation/transcoder/transcoder_install.txt";
					
					echo "<p>
					There was an issue with your media processing driver installation. We were unable to bring the media processing interfaces up.<br />
					Please try re-installing the Media Processing drivers. If this issue occurs more then once, please download the file \"<a href=\"transcoder/transcoder_install.txt\" target=\"_blank\">Transcoder Install</a>\" and attach it with an email to \"<a href='mailto:techdesk@sangoma.com?subject=Cannont Compile Media Processing Drivers&body=$body&attachment=\"$file_location\"'>techdesk@sangoma.com</a>\"\".
					</p>";
				}
				elseif ($install_script == "error")
				{
					$body = "Dear Support;%0D%0AI am having trouble compiling my transcoding drivers using the Sangoma Media Gateway Transcoding Web Installation.%0D%0AAttached is the output from the transcoder installation%0D%0ARegards";
					$file_location = $_SESSION['smg_root_path'] . "/nginx/html/php/installation/transcoder/transcoder_install.txt";
					
					echo "<p>
					There was an issue with your transcoding driver installation. We were unable to install the transcoding drivers.<br />
					Please try re-installing the Transcoding drivers and make sure that the " . $_SESSION['smg_root_path'] . "/src exists. If this issue occurs more then once, please download the file \"<a href=\"transcoder/transcoder_install.txt\" target=\"_blank\">Transcoder Install</a>\" and attach with an email to \"<a href='mailto:techdesk@sangoma.com?subject=Cannont Compile Transcoding Drivers&body=$body&attachment=\"$file_location\"'>techdesk@sangoma.com</a>\"\".
					</p>";					
				}
			}
	}

	if ($_REQUEST['install'] == "Generate Configuration" && $no_configure != "yes")
	{
		
		//Enter all the codecs requested into the database. Error out if no codecs were entered.
		
		foreach ($_REQUEST as $key => $value)
		{	
			if (preg_match('/^codec[0-9]*/',$key))
			{
				$pass = "test";
			}
		}
		
		
			$table_name = "user_codecs";
			//clean out the existing database
			//drop table
			$transcode->data->drop_table($transcode->db_location, $table_name);
			
			//create table		
			$parameters = "id int primary key, codec_syntax varchar(30)";
			$transcode->data->create_table($transcode->db_location, $table_name, $parameters);	
		
		
			$counter = 1;
			//Insert the users select codecs into the database
			foreach ($_REQUEST as $key => $value)
			{	
				if (preg_match('/^codec[0-9]*/',$key))
				{
					//echo "$counter = $key , $value<br />";
					$table_name = "user_codecs";
					//Check if something exists as the table entry
					$param = "id";
					$where = "id = $counter";
					$return = $transcode->data->select_statement($transcode->db_location, $table_name, $param, $where);
					
					//if it doesn't, insert the entry
					$insert_param = "id, codec_syntax";
					$insert_values = "$counter, \"$value\"";
					$transcode->data->insert_statement($transcode->db_location, $table_name, $insert_param, $insert_values);
					
					$counter++;
				}
			}
			
			//Check if the bind address and port are entered. If so, enter those values into the database
			if ($_REQUEST['bind_addr'] != "" && $_REQUEST['bind_port'] != "")
			{
				$table_name = "transcode_bind";
				
				$where = "1";
				$return = $transcode->data->select_statement($transcode->db_location, $table_name, "bind_addr", $where);
				
				if ($return['id'] != "")
				{
					//update the table
					$update_param = "bind_addr = \"" . $_REQUEST['bind_addr'] . "\", bind_port = \"" . $_REQUEST['bind_port'] . "\"";
					$transcode->data->update_table($transcode->db_location, $table_name, $update_param, $where);
				}
				elseif ($return['id'] == "")
				{
					//insert new data
					$insert_param = "id, bind_addr, bind_port";
					$insert_values = "1, \"" . $_REQUEST['bind_addr'] . "\", bind_port = \"" . $_REQUEST['bind_port'] . "\"";
					$transcode->data->insert_statement($transcode->db_location, $table_name, $insert_param, $insert_values);
				}
			}
					$pass = "no";
		if ($pass == "yes")
		{
	?>
    <hr />
    <h3>Media Processing Configuration Status</h3>
    <table>
    	<th>Process</th>
        <th>Status</th>
        <tr>
            <td>Shutting Down ALL Media Processing Processes</td>
            <?php
		exec ("/usr/sbin/sngtc_server_ctrl stop");
		exec ("echo $?", $output);
		
		if ($output[0] == 0)
		{
			?>
            <td width="100px" align="right"><font color="green">DONE</font></td>
        </tr>   
        <tr> 
            <td>Generating Media Processing Driver Scripts</td>
         	<?php
			//Create /etc/sysconfig/network_scripts file for internal transcoder cards selected
			
			$transcode->ifcfg();
			
			$check = 0;
			//check completion
			if ($check == 0)
			{
			?>
            <td width="100px" align="right"><font color="green">DONE</font></td>
        </tr>
        <tr>
            <td>Bringing Media Processing Interfaces Up</td>
            <?php
				//Bring up interfaces just created using ifup command
				$check = 1;
				//Check Completion
				if ($check == 0)
				{
			?>
            <td width="100px" align="right"><font color="green">DONE</font></td>
        </tr>
        <tr>    
            <td>Generating Gateway Configuration Files</td>            
            <?php
					//Find the number of entries in the database table
					$transcode->num_entries();

					//Create /usr/local/smg/conf/autoload_configs/sangoma_codec.conf
					$transcode->sangoma_codec();
					
					//Create /etc/sngtc/sngtc_server.conf 
					$transcode->sngtc_server();
					
					//Check if the file got created successfully
					if ($check == 0)
					{
			?>
            <td width="100px" align="right"><font color="green">DONE</font></td>
        </tr>
        <tr>    
            <td>Starting ALL Media Processing process</td>            
            <?php
						//Start the sngtc_server_ctrl process
						exec ("/usr/sbin/sngtc_server_ctrl start");
						exec ("echo $?", $start_process);						
						
						if ($start_process[0] == 0)
						{
							$transcode_complete = "yes";
			?>
			<td width="100px" align="right"><font color="green">DONE</font></td>            
            <?php
						}
						else
						{
							$server_start = "error";
							//Failed to start the sngtc_server_ctrl process
			?>
			<td width="100px" align="right"><font color="red">ERROR</font></td>            
            <?php							
						}
					}
					else
					{
						$sngtc_script = "error";
						//Failed creating the sngtc.xml file
			?>
            <td width="100px" align="right"><font color="red">ERROR</font></td>
			<?php						
					}
				}
				else
				{
					$interface_up = "error";
					//Failed bringing up the interfaces
			?>
            <td width="100px" align="right"><font color="red">ERROR</font></td>
			<?php					
				}	
			}
			else
			{
				$network_script = "error";
				//Failed creating the network script files
			?>
            <td width="100px" align="right"><font color="red">ERROR</font></td>
			<?php
			}
		}
		else
		{
			$server_stop = "error";
			//Could not stop sngtc_server_ctrl
			?>
			<td width="100px" align="right"><font color="red">ERROR</font></td>
            <?php
		}
		?>
        </tr>
    </table>    
    <?php
		}
		if ($transcode_complete == "yes")
		{
	?> 
    <p>
    	Media Processing installation completed successfully and the Media Processing processes have been started.<br />
        Please proceed to the <a href="../controls.php">Control Panal</a> in order to start the Gateway.
    </p>
    <?php
		}
		elseif ($pass == "no")
		{
			echo "<hr />\n";
			echo "<h4>Media Processing Configuration Errors</h4>\n";
			echo "<p><font color=\"red\">Please select at least <b>1</b> codec in order to complete the Media Processing Configuration</font></p>\n";
		}
	}
	//FusionPBX Integration
	require_once "../fusionpbx/includes/footer.php";
}
else
{
	header( 'Location:../index.php' ) ;
}