<?php
/*
	SMG WebGUI
	Version: 1.0

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

session_start();

class create_database extends database_class
{	
	private $table_col = ""	;	//Contains the table columns for a particular table required

	//Checks the schema for that schema and tells me if the tables are the same. If they are not the same it replaces the existing table with the new one.
	function check_schema($db_location, $table_name)
	{
		//Checks if the database exists
		try
		{
			//open the database			
			$db = new PDO ($db_location);
			
			$resq = $db->query ("PRAGMA table_info(" . $table_name . ")");
			$cols = $resq->fetchAll (PDO::FETCH_BOTH);
			$num = count ($cols);
			//echo "Number of columns = " . $num . "\n\n<br />";
			for ($i=0; $i<$num; $i++)
			{
				$numfld = count ($cols[$i]);
				/*for ($j=0; $j<$numfld; $j++)
				{
					echo $cols[$i][$j] . " ";
				}
				echo "<br />";*/
			}
			return $num;
			
			// close the database connection
			$db = NULL;
		}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}
	
	}

	function database_creation()
	{
		//Runs the check for the file
		$db_location = "sqlite:sqlite/cardinfo.db";
		$pathtemp = $_SESSION['path'] . "/sqlite";
		$path = preg_replace ("/\s*/m", "", $pathtemp);		
		$cmd = "ls $path | grep -c cardinfo.db";

		$output = shell_exec($cmd);		

		//If statement that controls the output
		if ($output[0] == 0)
		{	
			//Create required tables
			$table_name = "t1e1_profile";
			$parameters = "id int primary key, profile_name varchar(60), line_type varchar(10), protocol varchar(10), switchtype varchar(30), signalling varchar(30), ton_name varchar(100), ton_value varchar(100), npi_name varchar(100), npi_value varchar(100), facility varchar(10), facility_timeout int, bearer_ITC varchar(30), bearer_UIL varchar(30)";
			parent::create_table($db_location, $table_name, $parameters);

			$table_name = "bri_profile";
			$parameters = "id int primary key, profile_name varchar(60), conn_type varchar(10), sig_type varchar(10), interface varchar(10), switchtype varchar(30), tei int, overlap varchar(10), ton_name varchar(100), ton_value varchar(100), npi_name varchar(100), npi_value varchar(100), bearer_ITC varchar(30), bearer_UIL varchar(30), msn varchar(100)";
			parent::create_table($db_location, $table_name, $parameters);

			$table_name = "analog_profile";
			$parameters = "id int primary key, profile_name varchar(60), conn_type varchar(10), codec varchar(10), operation_mode varchar(10), hangup_polarity varchar(20), answer_polarity varchar(20),callerid varchar(20), tones varchar(20), call_waiting varchar(20), three_way varchar(20), call_swap varchar(20), digit_timeout int, max_digits int, polarity_delay int";
			parent::create_table($db_location, $table_name, $parameters);

			//Creates the card_present table
			$table_name = "card_present";
			$parameters = "id int primary key, dev_name varchar(60), pci_slot int, pci_bus int, num_ports int, firmware int, echo varchar(20), analog_location int, num_te int, num_nt int";
			parent::create_table($db_location, $table_name, $parameters);		
	
			//Creates the SS7 Linkset Profile Table
			$table_name = "ss7_linkset_profile";
			$parameters = "id int primary key, profile_name varchar(60), apc int, minactive int";
			parent::create_table($db_location, $table_name, $parameters);	

			//Creates the SS7 ISUP Profile Table
			$table_name = "ss7_isup_profile";
			$parameters = "id int primary key, profile_name varchar(60), spc int, ssf varchar(30), route varchar(60)";
			parent::create_table($db_location, $table_name, $parameters);	
	
			//Creates the SS7 Route Profile Table
			$table_name = "ss7_route_profile";
			$parameters = "id int primary key, profile_name varchar(60), dpc int, linksets varchar(100), stp varchar(10)";
			parent::create_table($db_location, $table_name, $parameters);	
	
			//Creates the Hosts Table
			$table_name = "hosts";
			$parameters = "id int, hostname varchar(100), ssh_port int, username varchar(100), smg_version varchar(50), relay_port int";
			parent::create_table($db_location, $table_name, $parameters);		
			
			//Creates the transcoding table
			$table_name = "transcode";
			$parameters = "id int primary key, interface varchar(30), ip_address varchar(30), net_mask varchar(30), mac_addr varchar(30), num_modules int, nibble varchar(30)";
			parent::create_table($db_location, $table_name, $parameters);	
			
			//Creates the transcoding codec	table. This is the table which the users chosen codecs get placed
			$table_name = "user_codecs";
			$parameters = "id int primary key, codec_syntax varchar(30)";
			parent::create_table($db_location, $table_name, $parameters);	
			
			//Creates the transcoding codec	table. This is the table which the users chosen codecs get placed
			$table_name = "transcode_bind";
			$parameters = "id int primary key, bind_addr varchar(30), bind_port varchar(30)";
			parent::create_table($db_location, $table_name, $parameters);	
	
			//Insert Default Profiles
			$table_name = "t1e1_profile";
			$parameters = "id, profile_name, line_type, protocol, switchtype, signalling, facility, bearer_ITC";
			
			$values = "1, \"T1 PRI CPE\", \"T1\", \"CCS\", \"NI2\", \"PRI CPE\", \"no\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);
			
			$values = "2, \"E1 PRI CPE\", \"E1\", \"CCS\", \"EuroISDN\", \"PRI CPE\", \"no\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);
			
			$values = "3, \"T1 PRI NET\", \"T1\", \"CCS\", \"NI2\", \"PRI NET\", \"no\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);

			$values = "4, \"E1 PRI NET\", \"E1\", \"CCS\", \"EuroISDN\", \"PRI NET\", \"no\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);		

			//Insert Default BRI Profiles
			$table_name = "bri_profile";
			$parameters = "id, profile_name, conn_type, sig_type,  interface, switchtype, tei, overlap, bearer_ITC";
			
			$values = "1, \"BRI PTMP CPE\", \"TE\", \"CPE\", \"ptmp\", \"EuroISDN\", \"\", \"disable\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);
			
			$values = "2, \"BRI PTMP NET\", \"NT\", \"NET\", \"ptmp\", \"EuroISDN\", \"\", \"disable\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);

			$values = "3, \"BRI PTP CPE\", \"TE\", \"CPE\", \"ptp\", \"EuroISDN\", \"\", \"disable\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);
						
			$values = "4, \"BRI PTP NET\", \"NT\", \"NET\", \"ptp\", \"EuroISDN\", \"\", \"disable\", \"\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);			
			
			//Insert Default Analog Profiles
			$table_name = "analog_profile";
			$parameters = "id, profile_name, codec, operation_mode, hangup_polarity, answer_polarity, callerid, tones, call_waiting, three_way, call_swap, polarity_delay";
			
			$values = "1, \"ANALOG MULAW\", \"MULAW\", \"FCC\", \"disable\", \"disable\", \"enable\", \"us\", \"disable\", \"disable\", \"disable\", \"600\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);
			
			$values = "2, \"ANALOG ALAW\", \"ALAW\", \"TBR21\", \"disable\", \"disable\", \"enable\", \"us\", \"disable\", \"disable\", \"disable\", \"600\"";
			parent::insert_statement($db_location, $table_name, $parameters, $values);
			
		}
		else
		{
			//Check if the tables have the right amount of parameters
			
			//echo "t1<br />";
			$table_name = "t1e1_profile";
			$table_col = $this->check_schema($db_location, $table_name);
			if ($table_col != 14)
			{
				parent::drop_table($db_location, $table_name);
				//Create required tables
				$parameters = "id int primary key, profile_name varchar(60), line_type varchar(10), protocol varchar(10), switchtype varchar(30), signalling varchar(30), ton_name varchar(100), ton_value varchar(100), npi_name varchar(100), npi_value varchar(100), facility varchar(10), facility_timeout int, bearer_ITC varchar(30), bearer_UIL varchar(30)";
				parent::create_table($db_location, $table_name, $parameters);
				
				//Insert Default Profiles
				$parameters = "id, profile_name, line_type, protocol, switchtype, signalling, facility, bearer_ITC";
				
				$values = "1, \"T1 PRI CPE\", \"T1\", \"CCS\", \"NI2\", \"PRI CPE\", \"no\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);
				
				$values = "2, \"E1 PRI CPE\", \"E1\", \"CCS\", \"EuroISDN\", \"PRI CPE\", \"no\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);
				
				$values = "3, \"T1 PRI NET\", \"T1\", \"CCS\", \"NI2\", \"PRI NET\", \"no\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);
	
				$values = "4, \"E1 PRI NET\", \"E1\", \"CCS\", \"EuroISDN\", \"PRI NET\", \"no\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);									
			}
			//echo "bri<br />";

			$table_name = "bri_profile";
			$table_col = $this->check_schema($db_location, $table_name);
			if ($table_col != 15)
			{
				$parameters = "id int primary key, profile_name varchar(60), conn_type varchar(10), sig_type varchar(10), interface varchar(10), switchtype varchar(30), tei int, overlap varchar(10), ton_name varchar(100), ton_value varchar(100), npi_name varchar(100), npi_value varchar(100), bearer_ITC varchar(30), bearer_UIL varchar(30), msn varchar(100)";				
				parent::drop_table($db_location, $table_name);
				//Create required tables
				parent::create_table($db_location, $table_name, $parameters);
				
				//Insert Default Profiles
				$parameters = "id, profile_name, conn_type, sig_type,  interface, switchtype, tei, overlap, bearer_ITC";
				
				$values = "1, \"BRI PTMP CPE\", \"TE\", \"CPE\", \"ptmp\", \"EuroISDN\", \"\", \"disable\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);
				
				$values = "2, \"BRI PTMP NET\", \"NT\", \"NET\", \"ptmp\", \"EuroISDN\", \"\", \"disable\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);
	
				$values = "3, \"BRI PTP CPE\", \"TE\", \"CPE\", \"ptp\", \"EuroISDN\", \"\", \"disable\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);
							
				$values = "4, \"BRI PTP NET\", \"NT\", \"NET\", \"ptp\", \"EuroISDN\", \"\", \"disable\", \"\"";
				parent::insert_statement($db_location, $table_name, $parameters, $values);										
			}
			//echo "analog<br />";

			$table_name = "analog_profile";
			$table_col = $this->check_schema($db_location, $table_name);
			if ($table_col != 15)
			{
				//echo "here";
				$parameters = "id int primary key, profile_name varchar(60), conn_type varchar(10), codec varchar(10), operation_mode varchar(10), hangup_polarity varchar(20), answer_polarity varchar(20), callerid varchar(20), tones varchar(20), call_waiting varchar(20), three_way varchar(20), call_swap varchar(20), digit_timeout int, max_digits int, polarity_delay int";			
				parent::drop_table($db_location, $table_name);
				//Create required tables
				parent::create_table($db_location, $table_name, $parameters);
				
				//Insert Default Profiles
				$parameters = "id, profile_name, codec, operation_mode, hangup_polarity, answer_polarity, callerid, tones, call_waiting, three_way, call_swap, polarity_delay";
			
				$values = "1, \"ANALOG MULAW\", \"MULAW\", \"FCC\", \"disable\", \"disable\", \"enable\", \"us\", \"disable\", \"disable\", \"disable\", 600";
				parent::insert_statement($db_location, $table_name, $parameters, $values);
			
				$values = "2, \"ANALOG ALAW\", \"ALAW\", \"TBR21\", \"disable\", \"disable\", \"enable\", \"us\", \"disable\", \"disable\", \"disable\", 600";
				parent::insert_statement($db_location, $table_name, $parameters, $values);						
			}			


			//Creates the card_present table
			$table_name = "card_present";
			$parameters = "id int primary key, dev_name varchar(60), pci_slot int, pci_bus int, num_ports int, firmware int, echo varchar(20), analog_location int, num_te int, num_nt int";	
			$insert_parameters = "id , dev_name, pci_slot , pci_bus , num_ports , firmware , echo , analog_location , num_te , num_nt ";	
			parent::check_schema($db_location, $table_name, $parameters, "10", $insert_parameters);
	
			//Creates the SS7 Linkset Profile Table
			$table_name = "ss7_linkset_profile";
			$parameters = "id int primary key, profile_name varchar(60), apc int, minactive int";
			$insert_parameters = "id , profile_name , apc , minactive ";
			parent::check_schema($db_location, $table_name, $parameters, "4", $insert_parameters);					

			//Creates the SS7 ISUP Profile Table
			$table_name = "ss7_isup_profile";
			$parameters = "id int primary key, profile_name varchar(60), spc int, ssf varchar(30), route varchar(60)";
			$insert_parameters = "id , profile_name , spc , ssf , route ";
			//parent::check_schema($db_location, $table_name, $parameters, "5", $insert_parameters);		
	
			//Creates the SS7 Route Profile Table
			$table_name = "ss7_route_profile";
			$parameters = "id int primary key, profile_name varchar(60), dpc int, linksets varchar(100), stp varchar(10)";
			$insert_parameters = "id , profile_name , dpc , linksets , stp";	
			//parent::check_schema($db_location, $table_name, $parameters, "5", $insert_parameters);
			
			//Creates the SS7 Route Profile Table
			$table_name = "hosts";
			$parameters = "id int, hostname varchar(100), ssh_port int, username varchar(100), smg_version varchar(50), relay_port int";
			$insert_parameters = "id, hostname , ssh_port , username , smg_version , relay_port ";	
			//parent::check_schema($db_location, $table_name, $parameters, "6", $insert_parameters);
			
			//Creates the transcoding table
			$table_name = "transcode";
			$parameters = "id int primary key, interface varchar(30), ip_address varchar(30), net_mask varchar(30), mac_addr varchar(30), num_modules int, nibble varchar(30)";
			$insert_parameters = "id, interface, ip_address, net_mask, num_modules, nibble";
			parent::check_schema($db_location, $table_name, $parameters, "7", $insert_parameters);
			
			//Creates the transcoding codec	table. This is the table which the users chosen codecs get placed
			$table_name = "user_codecs";
			$parameters = "id int primary key, codec_syntax varchar(30)";
			$insert_parameters = "id, codec_syntax";
			parent::check_schema($db_location, $table_name, $parameters, "2", $insert_parameters);
			//parent::create_table($db_location, $table_name, $parameters);	
			
			//Creates the transcoding codec	table. This is the table which the users chosen codecs get placed
			$table_name = "transcode_bind";
			$parameters = "id int primary key, bind_addr varchar(30), bind_port varchar(30)";
			$insert_parameters = "id, bind_addr, bind_port";
			parent::check_schema($db_location, $table_name, $parameters, "3", $insert_parameters);			
	
		}
	}
}

?>